=== debian/changelog ===
eeshow (0.git20170731-2) experimental; urgency=medium

  * bump standards version and dh compat
  * move package to electronics team and salsa.d.o

 -- W. Martin Borgert <debacle@debian.org>  Sat, 05 May 2018 18:44:25 +0000

eeshow (0.git20170731-1) experimental; urgency=medium

  * new upstream snapshot

 -- W. Martin Borgert <debacle@debian.org>  Sat, 02 Dec 2017 20:27:00 +0000

eeshow (0.git20161102-1) experimental; urgency=low

  * Initial release. (Closes: #842211)

 -- W. Martin Borgert <debacle@debian.org>  Sun, 06 Nov 2016 21:48:00 +0000
